<table>
  <tr>
    <td colspan=2>
      <strong>gripe</strong>&nbsp;&nbsp;&nbsp;&nbsp;
      <a href=https://pypi.org/project/gripe><img src="https://img.shields.io/pypi/l/gripe.svg"></a>
      <a href=https://pypi.org/project/gripe><img src="https://badge.fury.io/py/gripe.svg"></a>
      <a href="https://github.com/elo-enterprises/gripe/actions/workflows/python-publish.yml"><img src="https://github.com/elo-enterprises/gripe/actions/workflows/python-publish.yml/badge.svg"></a><a href="https://github.com/elo-enterprises/gripe/actions/workflows/python-test.yml"><img src="https://github.com/elo-enterprises/gripe/actions/workflows/python-test.yml/badge.svg"></a>
    </td>
  </tr>
  <tr>
    <td width=15%><img src=https://raw.githubusercontent.com/elo-enterprises/gripe/master/img/icon.png style="width:150px"></td>
    <td>
      Shell-util library for python.  <br/>
      Includes helpers for subprocess invocation, shell-formatters / pretty-printers, and more.
      <br/>
    </td>
  </tr>
</table>

---------------------------------------------------------------------------------

  * [Overview](#overview)
  * [Features](#features)
    * [Shell-formatters / pretty-printers](#shell-formatters--pretty-printers)
    * [Subprocess Invocation](#subprocess-invocation)
  * [Installation](#installation)
  * [Usage (CLI)](#usage-cli)
  * [Usage (API)](#usage-api)
    * [OOP-style Dispatch](#oop-style-dispatch)
    * [Loading data when command-output is JSON](#loading-data-when-command-output-is-json)


---------------------------------------------------------------------------------

## Overview

The `gripe` library provides various shell-utilities for python.

-------------------------------------------------------------------------------

## Features

### Shell-formatters / pretty-printers

* A somewhat usable parser / grammar for bash
* Console support for [rich](https://rich.readthedocs.io/en/stable/index.html) & [rich protocols](https://rich.readthedocs.io/en/stable/protocol.html)

### Subprocess Invocation

There's a lot of shell-related libraries out there, especially for invocation (see for example [this list](https://www.pyinvoke.org/prior-art.html)).
The interface for `gripe` is hopefully unsurprising, and something that's convenient but not fancy.  It's a utility, and not a huge framework.  

The main goal is to provide an API that is simple and stable, without a ton of dependencies.

```pycon
>>> import gripe 
>>> proc = gripe.invoke('echo hello world')
>>> assert proc.succeeded
>>> assert proc.stdout.strip()=='hello world'
>>>
```

Beyond such basics, gripe includes support for [rich output](#) and uses pydantic for datastructures.

See the [API docs](#usage-api) for more detailed information.  


---------------------------------------------------------------------------------

## Installation

See [pypi](https://pypi.org/project/gripe/) for available releases.

```bash
$ pip install gripe
```

---------------------------------------------------------------------------------

## Usage (CLI)

The gripe library publishes a small CLI tool, mostly just for testing & demoing the API behaviour. See [the CLI docs](docs/cli/) for the latest (autogenerated) help.

-------------------------------------------------------------------------------

## Usage (API)

See also:

* [the unit-tests](tests/units) for some examples of library usage
* [the smoke-tests](tests/smoke/test.sh) for example usage of stand-alone scripts

### OOP-style Dispatch 

This uses `gripe.Invocation` and returns `gripe.InvocationResponse`.

```pycon
>>> import gripe 
```

### Loading data when command-output is JSON

```pycon
>>> import gripe 
>>> 
```
